com.google.common.collect

## Class ForwardingSet<E>

- java.lang.Object
- - com.google.common.collect.ForwardingObject
  - - com.google.common.collect.ForwardingCollection<E>
    - - com.google.common.collect.ForwardingSet<E>

- All Implemented Interfaces:
    java.lang.Iterable<E>, java.util.Collection<E>, java.util.Set<E>
  Direct Known Subclasses:
    ForwardingSortedSet, TypeToken.TypeSet

      @GwtCompatible
      public abstract class ForwardingSet<E>
      extends ForwardingCollection<E>
      implements java.util.Set<E>

  A set which forwards all its method calls to another set. Subclasses should override one or more methods to modify the behavior of the backing set as desired per the decorator pattern.

  Warning: The methods of `ForwardingSet` forward indiscriminately to the methods of the delegate. For example, overriding `ForwardingCollection.add(E)` alone will not change the behavior of `ForwardingCollection.addAll(java.util.Collection<? extends E>)`, which can lead to unexpected behavior. In this case, you should override `addAll` as well, either providing your own implementation, or delegating to the provided `standardAddAll` method.

  The `standard` methods are not guaranteed to be thread-safe, even when all of the methods that they depend on are thread-safe.

  Since:
    2.0

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ForwardingSet()` Constructor for use by subclasses.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected abstract java.util.Set<E>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.
    `boolean` | `equals(java.lang.Object object)`
    `int` | `hashCode()`
    `protected boolean` | `standardEquals(java.lang.Object object)` A sensible definition of `equals(java.lang.Object)` in terms of `ForwardingCollection.size()` and `ForwardingCollection.containsAll(java.util.Collection<?>)`.
    `protected int` | `standardHashCode()` A sensible definition of `hashCode()` in terms of `ForwardingCollection.iterator()`.
    `protected boolean` | `standardRemoveAll(java.util.Collection<?> collection)` A sensible definition of `ForwardingCollection.removeAll(java.util.Collection<?>)` in terms of `ForwardingCollection.iterator()` and `ForwardingCollection.remove(java.lang.Object)`.

    - ### Methods inherited from class com.google.common.collect.ForwardingCollection

      `add, addAll, clear, contains, containsAll, isEmpty, iterator, remove, removeAll, retainAll, size, standardAddAll, standardClear, standardContains, standardContainsAll, standardIsEmpty, standardRemove, standardRetainAll, standardToArray, standardToArray, standardToString, toArray, toArray`

    - ### Methods inherited from class com.google.common.collect.ForwardingObject

      `toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Set

      `add, addAll, clear, contains, containsAll, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray`

- - ### Constructor Detail

    - #### ForwardingSet

          protected ForwardingSet()

      Constructor for use by subclasses.

  - ### Method Detail

    - #### delegate

          protected abstract java.util.Set<E> delegate()

      Description copied from class: `ForwardingObject`
      Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `delegate()`. Concrete subclasses override this method to supply the instance being decorated.
      Specified by:
        `delegate` in class `ForwardingCollection<E>`

    - #### equals

          public boolean equals(@Nullable
                       java.lang.Object object)

      Specified by:
        `equals` in interface `java.util.Collection<E>`
      Specified by:
        `equals` in interface `java.util.Set<E>`
      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in interface `java.util.Collection<E>`
      Specified by:
        `hashCode` in interface `java.util.Set<E>`
      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### standardRemoveAll

          protected boolean standardRemoveAll(java.util.Collection<?> collection)

      A sensible definition of `ForwardingCollection.removeAll(java.util.Collection<?>)` in terms of `ForwardingCollection.iterator()` and `ForwardingCollection.remove(java.lang.Object)`. If you override `iterator` or `remove`, you may wish to override `ForwardingCollection.removeAll(java.util.Collection<?>)` to forward to this implementation.
      Overrides:
        `standardRemoveAll` in class `ForwardingCollection<E>`
      Since:
        7.0 (this version overrides the `ForwardingCollection` version as of 12.0)

    - #### standardEquals

          protected boolean standardEquals(@Nullable
                               java.lang.Object object)

      A sensible definition of `equals(java.lang.Object)` in terms of `ForwardingCollection.size()` and `ForwardingCollection.containsAll(java.util.Collection<?>)`. If you override either of those methods, you may wish to override `equals(java.lang.Object)` to forward to this implementation.
      Since:
        7.0

    - #### standardHashCode

          protected int standardHashCode()

      A sensible definition of `hashCode()` in terms of `ForwardingCollection.iterator()`. If you override `ForwardingCollection.iterator()`, you may wish to override `equals(java.lang.Object)` to forward to this implementation.
      Since:
        7.0